#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar 13 09:33:17 2019

@author: havard
"""
import pandas as pd


def decimalDegrees(str):
    if str[-1]== 'N' or str[-1]== 'E':
        a = int(str.split()[0].split('°')[0])
        b= float(str.split()[0].split('°')[1])
        return a + b/60
    else:
        a = int(str.split()[0].split('°')[0])
        b= float(str.split()[0].split('°')[1])
        return -a - b/60
            
def importPorts(type):
    if type == 1:
        str = '/Users/havard/Desktop/Master/Support_Files/container_ports.csv'
    elif type == 2:
        str = '/Users/havard/Desktop/Master/Support_Files/bulk_ports.csv'
    elif type == 3:
        str = '/Users/havard/Desktop/Master/Support_Files/lng_ports.csv'
    else:
        print('Wrong type for ports')
    df = pd.read_csv(str,encoding = "ISO-8859-1")
    df.dropna(subset=['Latitude','Longitude'],inplace=True)
    df.drop_duplicates(subset=['Latitude','Longitude'],inplace=True)
    df['Longitude'] = df['Longitude'].apply(decimalDegrees)
    df['Latitude'] = df['Latitude'].apply(decimalDegrees)
    return df

def importShips(type,maxYear):
    if type == 1:
        #str = '/Users/havard/Desktop/Master/Support_Files/panamax_container_list.csv'
        str = '/Users/havard/Desktop/Master/Support_Files/container.csv'
    elif type == 2:
        #str = '/Users/havard/Desktop/Master/Support_Files/panamax_bulk_list.csv'
        str = '/Users/havard/Desktop/Master/Support_Files/bulk.csv'
    elif type == 3:
        #str = '/Users/havard/Desktop/Master/Support_Files/lng_list.csv'
        str = '/Users/havard/Desktop/Master/Support_Files/lng.csv'
    else:
        print('Wrong type for ports')
    dfShips = pd.read_csv(str)
    dfShips.dropna(subset=['MMSI'],inplace=True)
    #Remove ships created after year of study
    def convDateToNum(str):
        temp = str.split('-')
        return int(temp[0])+int(temp[1])/100
    dfShips['Age'] = dfShips['Built'].apply(convDateToNum)
    dfShips = dfShips[dfShips['Age']<maxYear]
    
    dfShips = dfShips.drop(columns=['Age'])
    #Sort by date so the x newest ships can esily be found 
    dfShips.sort_values(by=['Built'],axis=0,ascending=False,inplace=True)
    return dfShips

    
